<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8" />
    <meta http-equiv="X-UA-Compatible" content="IE=edge" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>Document</title>
  </head>
  <body>
    <script></script>
  </body>

  <script>
    // Конструкция try..catch состоит из двух основных блоков: try, и затем catch:
    // try {
    //   // код ...
    // } catch (err) {
    //   // обработка ошибки
    // }

    // // Часть программы что дает ошибку
    let a = 5;

    // document.getElementById("div").innerHTML = a;
    // // ошибка в строке выше не позволила выполнить этот код
    // console.log(a);

    // try {
    // document.getElementById("div").innerHTML = a;
    // } catch (err) {
    //   console.log(err);
    // }
    // console.log(a);

    // try {
    //   document.getElementById("div").innerHTML = a;
    // } catch (err) {
    //   console.log(err.name);
    //   console.log(err.message);
    //   // Типы ошибок - https://developer.mozilla.org/ru/docs/Web/JavaScript/Reference/Global_Objects/Error
    // }
    // console.log(a);

    // Ошибку, о которой catch не знает, он не должен обрабатывать.
    // Для этого используется оператор throw

    // try {
    //   document.getElementById("div").innerHTML = a;
    // } catch (err) {
    //   if (err.name === "SyntaxError") {
    //     console.log("SyntaxError");
    //   } else {
    //     throw err;
    //   }
    // }

    // Выбрасывать собственную ошибку
    class NoPropertyError extends Error {
      constructor(property) {
        super();
        this.name = "NoPropertyError";
        this.message = `No property ${property}`;
        this.property = property;
      }
    }

    const array = [
      {
        name: "Ira",
        age: 29,
      },
      {
        age: 6,
      },
    ];

    const handleArray = () => {
      array.forEach((element) => {
        if (!element.name) {
          console.log(element);
          // throw new NoPropertyError("name");
        }
      });
    };

    try {
      handleArray();
    } catch (err) {
      console.log(err);
    } finally {
      console.log("inside finally");
    }

    console.log(1);

    // try {
    //   document.getElementById("div").innerHTML = a;
    // } catch (err) {
    //   if (err.name === "SyntaxError") {
    //     console.log("SyntaxError");
    //   } else {
    //     throw new CustomError();
    //   }
    // }

    // Конструкция finally

    // try {
    //   //  .. пробуем выполнить код ..
    //   код запроса на сервер
    // } catch (e) {
    //   //  .. перехватываем исключение ..
    //   console.log(err)
    // } finally {
    //   //  .. выполняем всегда ..
    // }
  </script>
</html>
